////////////////////////////////////
//miscellaneous functions
//
//
//

function Rand(min,max)
{
	//min to max-1 ie [min,max)
	return min + Math.floor(random()*(max-min));
}

function Sign(value)
{
	if(value>0){return 1;}
	if(value<0){return -1;}
	return 0;	
}
//for alias purposes

function rand(min,max)
{
	return Rand(min,max);
}

function sign(value)
{
	return Sign(value);
}

function random()
{
	//pseudo random number generator
	seed = (89723453 * seed + 42854321) % 1000000
	return abs(seed / 1000000.0);
}

function abs(value)
{
	if(value<0)
	{
		return -1 * value;
	}
	return value;
}

function calcangle(x, y) 
{
	return Math.atan2(y, x) ;
}

function maxof(a,max)
{
	if(a>max)
	{
		return max;
	}
	return a;
}

function minof(a,min)
{
	if(a<min)
	{
		return min;
	}
	return a;
}

function isox(x,y,w)
{
	//not used
	//pass in the grid square and return a location in screen coordinates 
	return (w/2) * (1 + x - y);
}

function isoy(x,y,w)
{
	//not used
	//pass in the grid square and return a location in screen coordinates 
	return (w/4) * (1 + y + x);
}

function screentoisox(sx,sy,w,offsetx,offsety)
{
	//not used
	//pass in screen coordinates and convert to iso x grid
	sx-=offsetx;
	sy-=offsety;
	//
	//
	return Math.round(((sx + 2 * sy)/w) - 1);
}

function screentoisoy(sx,sy,w,offsetx,offsety)
{
	//not used
	//pass in screen coordinates and convert to iso y grid
	sx-=offsetx;
	sy-=offsety;
	return Math.round((2*sy - sx)/w);
}

