//////////////////////////////////////////
//gamedataonline.js
//
//
//
//Modification History
//when		who		ref		what
//20oct18	ml				written
//
//Dependencies:
//Lots - requires all other scripts and arrays already
//be in existence
//
//Usage:
//Everything in here is changeable according to your game

//design - the variables and functions are all up for grabs
//so to speak. Change what you like
//
//
//
//General variables (keep these unless you don't need them)
//var DEBUGGING = true;
//var DEBUGGING = false;
var CAT_GAMESTATE_LOGO = 5;
var CAT_GAMESTATE_MENU = 0;
var CAT_GAMESTATE_NEWCONTINUE = 10;
var CAT_GAMESTATE_TESTGUI = 90999;

var CAT_GAMESTATE_GAME = 1000;
var CAT_GAMESTATE_NEXTLEVEL = 1001;
var levelloaded = 0;
var loadmode = 0;
var CAT_GAMESTATE_GUIMENUS = 10000;
var CAT_GAMESTATE_STATS = 10998;

var Game = new Object();
Game.character = 0;		

var togglepause = false;

var RESOLUTIONX = 1600;
var RESOLUTIONY = 900;
var fakeloading = 0;
var firsttimeload = true;
var mapgenbartext = "";
var notclickedyet = true;
var oksaving = 0;
var gamecomplete = false;
var gamepaused = false;
var pgamestate = -1; //for returning from inventory and spellbook......
var CAT_GAMESTATE_TESTGUI = 99999;
//
var firstframes = 0;
var levelframe = 0;
var gameover = 0; 
var gameovertime = 0;
var acknowledge = false;
var acknowledgetext = new Array();
var gameexists = false;
var battlemap = new Array(); //galactic map
var battlemap2 = new Array(); //ground battle map - split it into zones where each planet takes up a collection of grid cells
var consoletext = new Array();
var mapselected = -1; //map cell selected (galactic map)
var unitselected = -1; //build unit selected;
var overlayalphaold = 0.0; //value;
var overlayalphadirn = 1;//up or down 
var CREDITS = false; //for CREDITS to scroll up
var creditsy = 0;
var firsttime = true;
var menuframe = 0;
var mouseover = false;
var mouseoverrect = false;
var mouseimg = -1;
var mouseimgx = -1000;
var mouseimgy = -1000;
var mouseimgw = 0;
var mouseimgh = 0;
var mouseimgscale = 1;
var audioindex = -1;

var performance = 0;
var mx=0;
var my=0;

var oldgamestate = 0;
var mainloaded = false;

var GuiLoaded = false;

function drawgame()
{
	mx = mouse.x;
	my = mouse.y;
	if(gamestate==CAT_GAMESTATE_LOGO)
	{
        drawlogo();
	}
	loadstate=checkloadstate();
	if(mainloaded==false)
	{
		if(loadstate<100)
		{
		
			drawrect(100,RESOLUTIONY - 40,loadstate * (RESOLUTIONX - 200) / 100,40,'#3377EE',0);
			drawtext(RESOLUTIONX/2,RESOLUTIONY - 20,'Loading:'+loadstate+'%','#FFFFDD','40px ' + themefont,true);
			return;
		}
		if(GuiLoaded==false && loadstate>=100)
		{
			drawrect(100,RESOLUTIONY - 40,99 * (RESOLUTIONX - 200) / 100,40,'#3377EE',0);
			drawtext(RESOLUTIONX/2,RESOLUTIONY - 20,'Loading:99%','#FFFFDD','40px ' + themefont,true);
		}
	}
	if(loadstate<100 && mainloaded==false)
	{
		return;
	}
	else
	{
		if(firsttimeload)
		{
			resetgame();
			mainloaded = true;
			firsttimeload = false;
			//if(!ismobile){audioon!=audioon;}
			audioloadstate = 100;
			//loadgui, ptypes and other initialisation routines...
			drawrect(100,RESOLUTIONY - 40,99 * (RESOLUTIONX - 200) / 100,40,'#3377EE',0);
			drawtext(RESOLUTIONX/2,RESOLUTIONY - 20,'Loading:99%','#FFFFDD','40px ' + themefont,true);
			LoadGui();
			GuiLoaded = true;
			EmitterReset();//11oct2022
			ParticleReset();//11oct2022
		}
	}
	if(gamestate==CAT_GAMESTATE_LOGO)
	{
		return;
	}
	undergameupdate();//14oct2022
	basemenus();
	guimenus();
	gameupdate();//11oct2022
	EmitterUpdateAll();//11oct2022
	ParticleUpdateAll();//11oct2022
	ParticleDrawAll();//11oct2022
}

function toggleaudio(x,y)
{
	if(leftclicked())
	{	
		if(mx>=x - 40 && mx<=x + 40)
		{
			if(my>=y - 25 && my<=y + 25)
			{
				audioon = !audioon;
				playsound(CAT_AUDIO_CLICK,1);
				mouse.clicked = false;
				mouse.oclicked = false;
			}
		}
	}
}		

function updateaudio()
{
	//Called once per frame to handle audio transitions and the like
	if(audioloadstate<100)
	{
		return;
	}
	if((ismobile==true && mobileaudioenabled==true) || (ismobile==false))
	{
		if(audioon && BLOCKGAME==false)
		{	
			playmusic(MUSIC);
		}
		else
		{
			stopaudio(MUSIC);
		}
	}
}

function resetrand()
{
	seed = 1234567; 
}

function initgame()
{
}

function playai()
{
}

function resetgame()
{
}

function resetunits()
{
}
		

function resetmap()
{
}

function handleinput()
{
}

function drawbuttonhighlight()
{
	//draw a slightly highlighted version of the original image
	//or a rectangle
	if(mouseover)
	{
		drawanimimage(images[mouseimg].img,mouseimgx,mouseimgy,0,mouseimgscale,mouseimgscale,0,1,0,0.25,0);
		mouseimgscale = 1;
	}
	if(mouseoverrect)
	{
		drawrect(mouseimgx,mouseimgy,mouseimgw,mouseimgh,'#444444',-0.25);
	}
	mouseover = false;
	mouseoverrect = false;
}

function improvedbuttonhighlight(cat,sx,sy,fx,fy)
{
	//highlight an image - call after drawing the image with the drawanimimage command
	if(mouse.x>sx && mouse.x<fx && mouse.y>sy && mouse.y<fy)
	{
		drawanimimage(images[cat].img,(sx+fx)/2,(sy+fy)/2,0,1,1,0,1,0,0.25,0);
	}
}

function updategame()
{	
	
}

function updatebackdrop()
{
}

function drawbackdrop()
{
}

function basemenus()
{
	if(gamestate==CAT_GAMESTATE_MENU)
	{
		if(leftclicked() || frame>5)
		{
			gamestate=CAT_GAMESTATE_NEWCONTINUE;
		}
		return;
	}
	if(gamestate==CAT_GAMESTATE_NEWCONTINUE)
	{
		gamestate = CAT_GAMESTATE_GUIMENUS;
		audioon = true;
		oaudioon = true;
		playmusic(Resources_menumusic);
		MUSIC = Resources_menumusic;
		showad();
		
	}
	//if(gamestate>=CAT_GAMESTATE_GUIMENUS)
	//{
		
	//}
}


function addconsole(text)
{
	consoletext[consoletext.length] = text;
}

function drawconsole()
{
	drawdatalabel(50,500,780,580,"");
	var i = consoletext.length - 4;
	if(i<0)
	{
		i = 0;
	}
	var k = 0;
	for(var j=i;j<consoletext.length;j++)
	{
		drawtext(75,k*15+520,consoletext[j],"#EEEEEE","10px "+themefont,false);
		k++;
	}
}



function drawlogo()
{
	var c = 255 - parseInt(frame * 255/125);
	if(c<0)
	{
		c=0;
	}
	if(c>255)
	{
		c=255;
	}
	var d = 255 - parseInt(frame*255/30);
	{
		drawanimimage(images[CAT_LOGO].img,SW/2,SH/2,0,1,1,0,0,false,1,CAT_LOGO);
	}
	if(frame>180)
	{
		menuframe = 0;
		gamestate=CAT_GAMESTATE_MENU;
	}
			
}

function drawcreditsinfo()
{
	consoletext = new Array();
	consoletext[consoletext.length] = "Art, Design, Development, Programming";
	consoletext[consoletext.length] = AUTHOR+" "+YEAR;
	for(var i=0;i<consoletext.length;i++)
	{
		drawtext(SW/2,SH - 35+i*16,consoletext[i],themetext,themefontsize + ' ' +themefont,true);
	}
	consoletext = new Array();
}



function checkloadstate()
{
	var value = 0;
	var found = false;
	var count = 0;
	var LL = loadmax;
	return parseInt((loadprogress * 100) / loadmax);
}