//////////////////////////////////////////
//audio.js
//
//This module handles all audio processing
//
//
//Modification History
//when		who		ref		what
//20mar20	ml				written
//
//
//Dependencies:
//Required init.js to be called before this
//and depends on array audios[] to exist
//as it uses components of the audios[] array
//for animated image strips. In truth this should
//be decoupled but at this stage there is no need to
//
//
//Public Functions and Usage:
/*
loadaudio(i,file); //in init.js
*/

function loopaudio(i)
{
	try{
	if(i>=0 && i<audios.length)
	{
		audios[i].snd.loop = true;
	}
	}
	catch(e)
	{
		
	}
}

function unloopaudio(i)
{
	try
	{
	if(i>=0 && i<audios.length)
	{
		audios[i].snd.loop = false;
	}
	}
	catch(e)
	{
		
	}
}

function playsound(i,v)
{
	playsound(i);
}

function playaudio(i)
{
	//alias
	playsound(i);
}

function stopmusic(i)
{
	stopaudio(i);
}

function stopaudio(i)
{
	try
	{
	if(i>=0 && i<audios.length)
	{
		audios[i].snd.volume = 0;
		audios[i].snd.pause();
	}
	}
	catch(e)
	{
		
	}
}

function playsound(i)
{
	try
	{
	if(!audioon)
	{
		return;
	}
	if(audioloadstate!=100)
	{
		return;
	}
	if((ismobile==true && mobileaudioenabled==true) || (ismobile==false))
	{
		if(i>=0 && i<audios.length)
		{
			audios[i].snd.loop = false;
			audios[i].snd.volume = FXVOLUME;
			audios[i].snd.play();
		}
	}
	}
	catch(e)
	{
		
	}
}

function playmusic(m)
{
	try
	{
	if(!audioon)
	{
		return;
	}
	if(audioloadstate!=100)
	{
		return;
	}
	if((ismobile==true && mobileaudioenabled==true) || (ismobile==false))
	{
		for(var i=0;i<audios.length;i++)
		{
			if(i!=m)
			{
				if(audios[i].music)
				{
					audios[i].snd.pause();
				}
			}
			if(i==m)
			{
				if(audios[i].music)
				{
					audios[i].snd.loop = true;
					audios[i].snd.volume = MUSICVOLUME;
					audios[i].snd.play();
				}
			}
		}	
	}
	}
	catch(e)
	{
		
	}
}

function stopallaudio()
{
	try
	{
	for(var i=0;i<audios.length;i++)
	{
		audios[i].snd.pause();
	}
	}
	catch(e)
	{
		
	}
}
