/////////////////////////////////
//metrics.js
//
//Functions for sending data to server 
//to let us know how long people are
//playing for and any other pertinent
//information
//
//Written 24Mar2020
//
var SENTLAUNCH = false;
//

function updateserver()
{
	if(!METRICSACTIVE)
	{
		return;
	}
	if(PGAME=='mygame')
	{
		//alert('Default PGAME variable not set');
		return;
	}
	if(!SENTLAUNCH)
	{
		sendlaunch();
	}
	else
	{
		if(frame>60*60)
		{
			if(fps>0)
			{
				if((frame % (fps*60))==0)
				{
					sendtimespent();
				}
			}
		}
	}
}

function sendmetric(event,value)
{
	if(!METRICSACTIVE)
	{
		return;
	}
	if(navigator.onLine)
	{
		var url = encodeURI('https://mattiesgames.com/metrics/metric.php?game='+PGAME+"&event="+event+"&value="+value+"&uid="+UID+"&version="+VERSIONSTR);
		var http = new XMLHttpRequest();
		http.open("POST",url);
		http.setRequestHeader("Content-type","application/x-www-form-urlencoded");
		http.send();
	}
}

function sendlaunch()
{
	//send the launch request to indicate to me how often the game is being played
	if(PGAME=='mygame')
	{
		//alert('Default PGAME variable not set');
		return;
	}
	if(!METRICSACTIVE)
	{
		return;
	}
	if(navigator.onLine)
	{
		var url = encodeURI('https://mattiesgames.com/metrics/launch.php?game='+PGAME+"&uid="+UID+"&version="+VERSIONSTR);
		var http = new XMLHttpRequest();
		http.open("POST",url);
		http.setRequestHeader("Content-type","application/x-www-form-urlencoded");
		http.send();
		SENTLAUNCH = true;
	}
}

function sendtimespent()
{
	if(!METRICSACTIVE)
	{
		return;
	}
	if(PGAME=='mygame')
	{
		return;
	}
	if(navigator.onLine)
	{
		var url = encodeURI('https://mattiesgames.com/metrics/timespent.php?game='+PGAME+"&uid="+UID+"&version="+VERSIONSTR);
		var http = new XMLHttpRequest();
		http.open("POST",url);
		http.setRequestHeader("Content-type","application/x-www-form-urlencoded");
		http.send();
	}
}
