////////////////////
//particles.js
//Not used currently as too slow
//in the method applied.
//
//
//particle system for fires
var emitter = new Array();
var particle = new Array();
var hideparticles = false;
var PTYPE_FIRE = 1;
var PTYPE_SMOKE = 2;
//
var ETYPE_FIRE = 1;

function createemitter(etype,x,y)
{
	var j = -1;
	for(var i=0;i<emitter.length;i++)
	{
		if(emitter[i].reset)
		{
			j=i;
			break;
		}
	}
	if(j==-1)
	{
		j = emitter.length;
		emitter[j] = new Object();
		resetemitter(j);
		emitter[j].reset = false;
		emitter[j].life = -1;
		emitter[j].x = x;
		emitter[j].y = y;
		emitter[j].etype = etype;
	}
}

function launchparticle(ptype,ei)
{
	var j = -1;
	for(var i=0;i<particle.length;i++)
	{
		if(particle[i].reset)
		{
			j = i;
			break;
		}
	}
	if(j==-1)
	{
		j = particle.length;
		particle[j] = new Object();
		resetparticle(j);
	}
	particle[j].reset = false;
	var i = j;
	if(ptype==PTYPE_FIRE)
	{
		particle[i].x = emitter[ei].x + Rand(0,4)-2;
		particle[i].y = emitter[ei].y + Rand(0,4)-2;
		particle[i].vx = (Rand(0,100)-50)/500;
		particle[i].vy = (Rand(0,100)-80)/320;
		particle[i].red = 200;
		particle[i].green = 150;
		particle[i].blue = 40;
		particle[i].blend = 1;
		particle[i].alpha = 0.99;
		particle[i].da = -0.02;
		particle[i].life = 4;
		particle[i].dr = -4;
		particle[i].dg = -10;
		particle[i].db = -2;
		particle[i].w = 2;
		particle[i].h = 2;
	}
	if(ptype==PTYPE_SMOKE)
	{
		particle[i].x = emitter[ei].x + Rand(0,6)-3;
		particle[i].y = emitter[ei].y + Rand(0,8) - 10;
		particle[i].vy = -0.25;
		particle[i].vx = (Rand(0,100) - 50) / 1000;
		var q = Rand(0,32);
		particle[i].red = 128+q;
		particle[i].green = 128+q;
		particle[i].blue = 128+q;
		particle[i].blend = 0;
		particle[i].alpha = 0.49;
		particle[i].da = -0.01;
		particle[i].life = 10;
		particle[i].dr = -2;
		particle[i].dg = -2;
		particle[i].db = -2;
	}
}

function resetemitter(i)
{
	emitter[i].reset = true;
	emitter[i].x = 0;
	emitter[i].y = 0;
	emitter[i].life = 0;
	emitter[i].etype = 0;
}

function resetparticle(i)
{
	particle[i].reset = true;
	particle[i].x = -1000;
	particle[i].y = -1000;
	particle[i].vx = 0;
	particle[i].vy = 0;
	particle[i].color = "";
	particle[i].red = 0;
	particle[i].green = 0;
	particle[i].blue = 0;
	particle[i].blend = 0;
	particle[i].alpha = 0;
	particle[i].dr = 0;
	particle[i].dg = 0;
	particle[i].db = 0;
	particle[i].da = 0;
	particle[i].sx = 1
	particle[i].sy = 1
	particle[i].w = 2;
	particle[i].h = 2;
	particle[i].dsx = 0;
	particle[i].dsy = 0;
	particle[i].life = 0;
}

function cleanparticles()
{
	if(emitter.length>0 || particle.length>0)
	{
		particle.splice(0,particle.length);
		emitter.splice(0,emitter.length);
	}
}

function updateparticles()
{
	if(hideparticles)
	{
		return;
	}
	for(var i=0;i<emitter.length;i++)
	{
		if(emitter[i].life>0)
		{
			emitter[i].life--;
			emitter[i].reset = false;
		}
		else
		{
			if(emitter[i].life<0)
			{
				emitter[i].reset=false;
			}
		}
		if(emitter[i].life!=0)
		{
			if(emitter[i].etype = ETYPE_FIRE)
			{
				///emit particles
				for(var j=0;j<3;j++)
				{
					launchparticle(PTYPE_FIRE,i);
				}
				///emit particles
				launchparticle(PTYPE_SMOKE,i);
			}
		}
		else
		{
			if(emitter[i].reset==false)
			{
				resetemitter(i);
			}
		}
	}
	for(var i=0;i<particle.length;i++)
	{
		if(particle[i].life>0)
		{
			particle[i].life--;
			particle[i].x+=particle[i].vx;
			particle[i].y+=particle[i].vy;
			particle[i].red+=particle[i].dr;
			particle[i].green+=particle[i].dg;
			particle[i].blue+=particle[i].db;
			particle[i].alpha+=particle[i].da;
			if(particle[i].alpha<=0)
			{
				particle[i].life = 0;
				particle[i].alpha = 0;
			}
			particle[i].sx+=particle[i].dsx;
			particle[i].sy+=particle[i].dsy;
			if(particle[i].sx<0.01)
			{
				particle[i].sx = 0.01;
			}
			if(particle[i].sy<0.01)
			{
				particle[i].sy = 0.01;
			}
			var red = "";
			var grn = "";
			var blu = "";
			if(particle[i].red<0)
			{
				particle[i].red = 0;
			}
			if(particle[i].green<0)
			{
				particle[i].green = 0;
			}
			if(particle[i].blue<0)
			{
				particle[i].blue = 0;
			}
			if(particle[i].alpha<0)
			{
				particle[i].alpha = 0;
			}
			if(particle[i].red>255)
			{
				particle[i].red = 255;
			}
			if(particle[i].green>255)
			{
				particle[i].green = 255;
			}
			if(particle[i].blue>255)
			{
				particle[i].blue = 255;
			}
			red = String(particle[i].red.toString(16));
			grn = String(particle[i].green.toString(16));
			blu = String(particle[i].blue.toString(16));
			if(red=="0")
			{
				red="00";
			}
			if(grn=="0")
			{
				grn="00";
			}
			if(blu=="0")
			{
				blu="00";
			}
			if(red.length==1)
			{
				red = "0" + red;
			}
			if(grn.length==1)
			{
				grn = "0" + grn;
			}
			if(blu.length==1)
			{
				blu = "0" + blu;
			}
			particle[i].color = '#' + red + grn + blu;
			particle[i].reset = false;
		}
		else
		{
			if(particle[i].reset==false)
			{
				resetparticle(i);
			}
		}
	}
}

function drawparticles()
{
	if(hideparticles)
	{
		return;
	}
	for(var i=0;i<particle.length;i++)
	{
		if(particle[i].reset==false && particle[i].alpha>0 && particle[i].sx>0 && particle[i].sy>0 && particle[i].life>0)
		{
			var blend = particle[i].alpha;
			if(particle[i].blend==1)
			{
				blend*=-1;
			}
			drawrect(particle[i].x-(particle[i].w*particle[i].sx)/2,particle[i].y-(particle[i].h*particle[i].sy)/2,particle[i].w*particle[i].sy,particle[i].h*particle[i].sy,particle[i].color,blend)
		}
	}
}
