///////////////////
//Game Recorder
//Written ml 15mar2020
//purpose is to record and play back mouse data
//depends on init.js 
var gr_recording = new Array();
var gr_currentframe = 0;
var gr_PLAYING = false;
var gr_RECORDING = false;
var gr_ENABLE = false;

function gr_manage()
{
	if(gr_ENABLE)
	{
		//gr_recorderelement.style.display = "inline";
		gr_recordframe();
		gr_play();
	}
}

function gr_startrecording()
{
	gr_RECORDING = true;
	gr_PLAYING = false;
	gr_recording = new Array();
}

function gr_startplaying()
{
	gr_RECORDING = false;
	gr_PLAYING = true;
	gr_currentframe = 0;
}

function gr_stop()
{
	gr_RECORDING = false;
	gr_PLAYING = false;
}

function gr_recordframe()
{
	if(!gr_RECORDING)
	{
		return;
	}
	var i = gr_recording.length;
	gr_recording[i] = new Object();
	gr_recording[i].x = mouse.x;
	gr_recording[i].y = mouse.y;
	gr_recording[i].clicked = mouse.clicked;
	gr_recording[i].oclicked = mouse.oclicked;
	gr_recording[i].firstclicked = mouse.firstclicked;
	gr_recording[i].seed = seed;
	gr_recording[i].frame = frame;
}

function gr_play()
{
	if(!gr_PLAYING)
	{
		return;
	}
	var i = gr_currentframe;
	if(i<0 || i>=gr_recording.length)
	{
		gr_stop();
		return;
	}
	mouse.x = gr_recording[i].x;
	mouse.y = gr_recording[i].y;
	mouse.clicked = gr_recording[i].clicked;
	mouse.oclicked = gr_recording[i].oclicked;
	mouse.firstclicked = gr_recording[i].firstclicked;
	frame = gr_recording[i].frame;
	seed = gr_recording[i].seed;
	gr_currentframe++;
}
